<template>
  <div class="checkResult_bets">
    <div class="checkResult_bets-title flex flex-between flex-middle">
      <div>
        {{$t('bets.listBets')}}
      </div>
      <div>
        <BSwitch
          :checked="my"
          @change="(val)=>change(val)"
          :activeText="$t('common.all')"
          :inactiveText="$t('common.my')"></BSwitch>
      </div>
      <div>
        <img
          src="~/static/icons/copy.png"
          class="icon"
          alt="">
      </div>
    </div>
    <div
      class="checkResult_bets-list"
      v-if="bets.length">
      <div
        class="item flex"
        v-for="(item, key) in bets"
        :key="key">
        <div class="item_number color-white">{{key}}.</div>
        <div class="item_amount">{{item.amount}} EOS</div>
        <div class="item_hash color-white">{{item.tx}}</div>
        <a
          class="item_btn"
          target="_blank"
          :href="netUrl(item.tx)">view</a>
      </div>
    </div>
    <div class="checkResult_hash-revealed details-info flex flex-middle checkResult_bets-footer">
      <div class="info-mockup medium">
        β
      </div>
      <div class="details-info-description">
        <div class="title">{{$t('bets.startHash')}}</div>
        <div class="hash long color-white">{{details.compound_hash}}</div>
      </div>
      <div>
        <img
          src="~/static/icons/copy.png"
          @click="copy(details.compound_hash)"
          class="icon"
          alt="">
      </div>
    </div>
  </div>
</template>

<script>
  import copyClipboard from '~/components/utils/copy';
  import BSwitch from '~/components/UI/Switch';
  export default {
    name: "Bets",
    data() {
      return {
        my: false
      }
    },
    components: {
      BSwitch
    },
    computed: {
      bets() {
        const my = this.$store.state.gameDetails.details.my;
        const others = this.my ? [] : this.$store.state.gameDetails.details.others;
        return [...my, ...others];
      },
      details() {
        return this.$store.state.gameDetails.details;
      },
      isDemo() {
        return this.$store.state.common.demo;
      },
    },
    methods: {
      netUrl(tx) {
        const testnet = `https://local.bloks.io/transaction/${tx}?nodeUrl=http%3A%2F%2Ftestnet.16bit.game&systemDomain=eosio`;
        const mainnet = `https://www.bloks.io/transaction/${tx}`;
        return this.isDemo ? testnet : mainnet;
      },
      copy(text) {
        copyClipboard(text, this.$t('common.copied'));
      },
      formatDate(timestamp) {
        if (typeof timestamp === 'string') return new Date(timestamp).toLocaleTimeString();
        const date = new Date(timestamp * 1000);
        return date.toLocaleTimeString();
      },
      change(val) {
        this.ga('am');
        this.my = val;
      }
    }
  }
</script>
<style lang="scss" scoped>
@import '~/assets/styles/variables.scss';
@import '~/assets/styles/colorVariables.scss';
.checkResult {
  &_hash {
    &-revealed {
      background-color: #222B3E;
      padding: 19px;
      .title {
        font-size: 12px;
      }
      .hash {
        font-size: 12px;
        text-overflow: ellipsis;
        overflow: hidden;
      }
      .details {
        &-info {
          &-description {
            white-space: nowrap;
            overflow: hidden;
            padding: 0px $paddingDefault;
            word-break: break-all;
            .title {
              margin-bottom: $marginMini / 2;
            }
          }
        }
      }
    }
  }
  &_bets {
    .icon {
      max-width: 16px;
      max-height: 16px;
    }
    &-title {
      padding: 14px 19px;
      background-color: rgba($grey, .3);
      font-size: 16px;
      color: $grey;
    }
    &-list {
      max-height: 222px;
      overflow-y: auto;
      background-color: #252F44;
      .item {
        display: flex;
        align-items: center;
        justify-content: space-between;
        font-size: 12px;
        background-color: #252F44;
        padding: 12px 19px;
        &>div {
          margin: 0px 7px;
          &:first-of-type {
            margin-left: 0px;
          }
          &:last-of-type {
            marign-right: 0px;
          }
        }
        &:nth-of-type(even) {
          background-color: #283349;
        }
        &_number {
          color: $grey;
          max-width: 15px;
        }
        &_amount {
          color: white;
          max-width: 130px;
        }
        &_hash {
          color: $grey;
          flex: 1;
          padding-right: $paddingMini;
          overflow: hidden;
          white-space: nowrap;
          text-overflow: ellipsis;
        }
        &_btn {
          color: #FFC24A;
          text-decoration: underline;
          max-width: 20px;
        }
      }
    }
  }
}
</style>
